# Vue Bootstrap Pagination Component

> Learn how to use CoreUI’s Vue Pagination component with Bootstrap styles for flexible, framework-consistent UI.

## Overview

We use a large block of connected links for our pagination, making links hard to miss and easily scalable—all while providing large hit areas. Pagination is built with list HTML elements so screen readers can announce the number of available links. Use a wrapping `<nav>` element to identify it as a navigation section to screen readers and other assistive technologies.

In addition, as pages likely have more than one such navigation section, it's advisable to provide a descriptive `aria-label` for the `<nav>` to reflect its purpose. For example, if the pagination component is used to navigate between a set of search results, an appropriate label could be `aria-label="Search results pages"`.

```html
<template>
  <CPagination aria-label="Page navigation example">
    <CPaginationItem href="#">Previous</CPaginationItem>
    <CPaginationItem href="#">1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem href="#">Next</CPaginationItem>
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>
```
  
</Example>

## Working with icons

Looking to use an icon or symbol in place of text for some pagination links? Be sure to provide proper screen reader support with `aria` attributes.

```html
<template>
  <CPagination aria-label="Page navigation example">
    <CPaginationItem aria-label="Previous" href="#"
      ><span aria-hidden="true">&laquo;</span></CPaginationItem
    >
    <CPaginationItem href="#">1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem aria-label="Next" href="#"
      ><span aria-hidden="true">&raquo;</span></CPaginationItem
    >
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>
```
  
</Example>

## Disabled and active states

Pagination links are customizable for different circumstances. Use `disabled` for links that appear un-clickable and `.active` to indicate the current page.

While the `disabled` prop uses `pointer-events: none` to _try_ to disable the link functionality of `<a>`s, that CSS property is not yet standardized and doesn't account for keyboard navigation. As such, we always add `tabindex="-1"` on disabled links and use custom JavaScript to fully disable their functionality.

```html
<template>
  <CPagination aria-label="Page navigation example">
    <CPaginationItem aria-label="Previous" href="#" disabled
      ><span aria-hidden="true">&laquo;</span></CPaginationItem
    >
    <CPaginationItem href="#" active>1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem aria-label="Next" href="#"
      ><span aria-hidden="true">&raquo;</span></CPaginationItem
    >
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>
```
  
</Example>

## Sizing

Fancy larger or smaller pagination? Add `size="lg"` or `size="sm"` for additional sizes.

```html
<template>
  <CPagination size="lg" aria-label="Page navigation example">
    <CPaginationItem href="#">Previous</CPaginationItem>
    <CPaginationItem href="#">1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem href="#">Next</CPaginationItem>
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>
```
  
</Example>

```html
<template>
  <CPagination size="sm" aria-label="Page navigation example">
    <CPaginationItem href="#">Previous</CPaginationItem>
    <CPaginationItem href="#">1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem href="#">Next</CPaginationItem>
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>
```
  
</Example>

## Alignment

Change the alignment of pagination components with `align` property.

```html
<template>
  <CPagination align="center" aria-label="Page navigation example">
    <CPaginationItem disabled>Previous</CPaginationItem>
    <CPaginationItem href="#">1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem href="#">Next</CPaginationItem>
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>
```
  
</Example>

```html
<template>
  <CPagination align="end" aria-label="Page navigation example">
    <CPaginationItem disabled>Previous</CPaginationItem>
    <CPaginationItem href="#">1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem href="#">Next</CPaginationItem>
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>
```
  
</Example>


# React Bootstrap Pagination Component

> Learn how to use the React Bootstrap Pagination component from CoreUI to create accessible and responsive navigation between pages, including sizing, alignment, and icon support.

## Overview of React Bootstrap Pagination

The React Bootstrap Pagination component helps you build navigation for multi-page content, such as search results or article listings. It's based on semantic HTML with `<ul>` and `<li>` elements, ensuring accessibility and screen reader compatibility.

Wrap the component in a `<nav>` element and use a descriptive `aria-label` like `aria-label="Search results pages"` for clarity.

```html
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationExample = () => {
  return (
    <CPagination aria-label="Page navigation example">
      <CPaginationItem>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}
```

## Using icons in pagination

You can replace text in pagination buttons with icons or symbols. Make sure to include proper `aria-labels` for accessibility.

```html
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationWorkingWithIconsExample = () => {
  return (
    <CPagination aria-label="Page navigation example">
      <CPaginationItem aria-label="Previous">
        <span aria-hidden="true">&laquo;</span>
      </CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem aria-label="Next">
        <span aria-hidden="true">&raquo;</span>
      </CPaginationItem>
    </CPagination>
  )
}
```

## Disabled and active pagination items

Use the `disabled` prop to indicate non-interactive items and the `.active` class to highlight the current page. CoreUI handles keyboard accessibility with `tabindex="-1"` and JS-based interaction disabling.

```html
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationDisabledAndActiveExample = () => {
  return (
    <CPagination aria-label="Page navigation example">
      <CPaginationItem aria-label="Previous" disabled>
        <span aria-hidden="true">&laquo;</span>
      </CPaginationItem>
      <CPaginationItem active>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem aria-label="Next">
        <span aria-hidden="true">&raquo;</span>
      </CPaginationItem>
    </CPagination>
  )
}
```

## Pagination sizing

Adjust the size of the React Bootstrap Pagination component with the `size` prop. Available values: `lg` (large), `sm` (small).

```html
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationSizingLargeExample = () => {
  return (
    <CPagination size="lg" aria-label="Page navigation example">
      <CPaginationItem>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}
```
```html
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationSizingSmallExample = () => {
  return (
    <CPagination size="sm" aria-label="Page navigation example">
      <CPaginationItem>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}
```

## Pagination alignment

Change pagination alignment using the `align` prop: `"start"`, `"center"`, or `"end"`.

```html
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationAlignmentExample = () => {
  return (
    <CPagination align="center" aria-label="Page navigation example">
      <CPaginationItem disabled>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}
```
```html
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationAlignment2Example = () => {
  return (
    <CPagination align="end" aria-label="Page navigation example">
      <CPaginationItem disabled>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}
```

## API reference

Here’s the API reference for the React Bootstrap Pagination component:

- [&lt;CPagination /&gt;](../api/#cpagination)
- [&lt;CPaginationItem /&gt;](../api/#cpaginationitem)
